apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ rocket_name }}
  name: {{ rocket_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ rocket_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ rocket_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ rocket_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    rollingParams:
      timeoutSeconds: 1800
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ rocket_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ rocket_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ rocket_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: ADMIN_PASS
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ rocket_name }}
        - name: ADMIN_USERNAME
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ rocket_name }}
        - name: Accounts_AvatarStorePath
          value: /app/uploads
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: LLNG_PROTO
{% if do_lemon %}
          value: https
        - name: LLNG_SSO_DOMAIN
          value: auth.{{ root_domain }}
{% else %}
          value: ""
        - name: LLNG_SSO_DOMAIN
          value: ""
{% endif %}
{% if matomo_api_public is defined %}
        - name: MATOMO_SITE_ID
          value: "{{ rocket_matomo_site_id }}"
        - name: MATOMO_URL
          value: {{ matomo_api_public }}/
{% else %}
        - name: MATOMO_SITE_ID
          value: ""
        - name: MATOMO_URL
          value: ""
{% endif %}
        - name: MONGO_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ rkmg_name }}
        - name: MONGO_HOST
          value: {{ rkmg_name }}-ready
        - name: MONGO_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ rkmg_name }}
        - name: MONGO_REPLICA_NAME
          valueFrom:
            secretKeyRef:
              key: database-replicaname
              name: {{ rkmg_name }}
        - name: MONGO_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ rkmg_name }}
        - name: NODE_ENV
          value: production
{% if do_ldap %}
        - name: NODE_TLS_REJECT_UNAUTHORIZED
          value: "{% if ldaps_address | default(False) and skip_ldap_verify | default(False) %}0{% endif %}"
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=rocket,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: rocket-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
{% else %}
        - name: NODE_TLS_REJECT_UNAUTHORIZED
          value: ""
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
{% endif %}
        - name: PROMETHEUS_ENABLED
          value: "{% if do_exporters %}yay{% endif %}"
        - name: PROMETHEUS_PORT
          value: '9113'
        - name: PORT
          value: '3000'
        - name: PUBLIC_PROTO
          value: https
{% if rocket_cloud_email and rocket_cloud_token %}
        - name: ROCKET_CLOUD_EMAIL
          valueFrom:
            secretKeyRef:
              key: email
              name: {{ rocket_name }}-cloud
        - name: ROCKET_CLOUD_TOKEN
          valueFrom:
            secretKeyRef:
              key: token
              name: {{ rocket_name }}-cloud
        - name: ROCKET_CLOUD_URL
          value: {{ rocket_cloud_url }}
{% else %}
        - name: ROCKET_CLOUD_EMAIL
          value: ""
        - name: ROCKET_CLOUD_TOKEN
          value: ""
        - name: ROCKET_CLOUD_URL
          value: ""
{% endif %}
        - name: ROCKET_COUNTRY
          value: {{ rocket_country }}
        - name: ROCKET_DOMAIN
          value: {{ rocketchat_fqdn }}
        - name: ROCKET_INDUSTRY
          value: {{ rocket_industry }}
        - name: ROCKET_INIT_MAX_RETRY
          value: "60"
        - name: ROCKET_INIT_TIMER
          value: "30"
        - name: ROCKET_LANG
          value: {{ lang_code }}
        - name: ROCKET_ORG_NAME
          value: {{ ldap_org_name | default(rocket_org_name) }}
        - name: ROCKET_ORG_TYPE
          value: {{ rocket_org_type }}
        - name: ROCKET_ORG_URL
{% if rocket_org_url | default(False) %}
          value: {{ rocket_org_url }}
{% else %}
          value: ""
{% endif %}
        - name: ROCKET_SAML_URL
{% if do_lemon %}
          value: https://auth.{{ root_domain }}
{% else %}
          value: ""
{% endif %}
        - name: ROCKET_SERVER_TYPE
          value: {{ rocket_server_type }}
        - name: ROCKET_SITE_NAME
          value: {{ rocket_site_name }}
        - name: ROCKET_WEB_MAX_RETRY
          value: "120"
        - name: ROCKET_WEB_TIMER
          value: "20"
        - name: SMTP_FROM
          value: rocket@{{ root_domain }}
        - name: SMTP_HOST
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_IGNORE_TLS
          value: "{{ 'tru' if (smtp_port | default(25) | int == 25) else ('fals' if (skip_smtp_verify | default(False)) else 'tru') }}e"
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_IGNORE_TLS
          value: "{{ 'tru' if (smtp_port | default(25) | int == 25) else ('fals' if (skip_smtp_verify | default(False)) else 'tru') }}e"
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
{% else %}
          value: ""
        - name: SMTP_IGNORE_TLS
          value: "true"
        - name: SMTP_PORT
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='rocketchat'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='rocketchat'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 58
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 60
          httpGet:
            path: /api/info
            port: 3000
          periodSeconds: 30
          timeoutSeconds: 5
        name: rocket
        ports:
        - containerPort: 3000
{% if do_exporters %}
        - containerPort: 9113
{% endif %}
        readinessProbe:
          httpGet:
            path: /api/info
            port: 3000
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ rocket_cpu_limit }}"
            memory: "{{ rocket_memory_limit }}"
          requests:
            cpu: "{{ rocket_cpu_request }}"
            memory: "{{ rocket_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 58
          initialDelaySeconds: 60
          periodSeconds: 30
          tcpSocket:
            port: 3000
{% endif %}
        volumeMounts:
{% if (do_ldap or do_lemon) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /app/uploads
          name: data
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% if do_lemon %}
        - mountPath: /saml
          name: saml
{% endif %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ rocket_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - emptyDir: {}
        name: data
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if do_lemon %}
      - name: saml
        projected:
          sources:
          - secret:
              items:
              - key: tls.crt
                path: tls.crt
              name: {{ rocket_name }}-saml
          - secret:
              items:
              - key: tls.key
                path: tls.key
              name: {{ rocket_name }}-saml
          - secret:
              items:
              - key: tls.crt
                path: lemon.crt
              name: {{ lemon_name }}-saml
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='rocketchat'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - rocket
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='rocketchat'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
